//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * アニメーションデータヘッダ
 * @author Junpee
 */

#ifndef ANIMATION_DATA_H_
#define ANIMATION_DATA_H_

namespace Lamp{

class CameraAnimationData;
class SceneNodeAnimationData;
class CharacterModelAnimationData;

//------------------------------------------------------------------------------
/**
 * アニメーションデータ
 */
class AnimationData{
friend class AnimationManager;
protected:
	//--------------------------------------------------------------------------
	/**
	 * シーケンス
	 */
	class Sequence{
	public:
		/**
		 * コンストラクタ
		 */
		Sequence() : length_(0.f), looped_(false){}

		/**
		* デストラクタ
		*/
		virtual ~Sequence(){}

		/**
		 * 代入コピー
		 * @param copy コピー元
		 */
		virtual void operator =(const Sequence& copy){
			length_ = copy.length_;
			looped_ = copy.looped_;
		}

		/// 長さ
		float length_;
		/// ループ
		bool looped_;

	private:
		// コピーコンストラクタの隠蔽
		Sequence(const Sequence& copy);

	};

public:
	//--------------------------------------------------------------------------
	// コピー
	//--------------------------------------------------------------------------
	/**
	 * コピー
	 * @return コピーされたアニメーションデータ
	 */
	virtual AnimationData* copy() const = 0;

	//--------------------------------------------------------------------------
	// シーケンス数
	//--------------------------------------------------------------------------
	/**
	 * シーケンス数の設定
	 * @param sequenceCount シーケンス数
	 */
	virtual void setSequenceCount(int sequenceCount) = 0;

	/**
	 * シーケンス数の取得
	 * @return シーケンス数
	 */
	virtual int getSequenceCount() const = 0;

	//--------------------------------------------------------------------------
	// 長さ
	//--------------------------------------------------------------------------
	/**
	 * 長さの設定
	 * @param sequence シーケンス
	 * @param length 長さ
	 */
	virtual void setLength(int sequence, float length){
		getSequence(sequence)->length_ = length;
	}

	/**
	 * 長さの取得
	 * @param sequence シーケンス
	 * @return 長さ
	 */
	virtual float getLength(int sequence) const{
		return getSequence(sequence)->length_;
	}

	//--------------------------------------------------------------------------
	// ループ
	//--------------------------------------------------------------------------
	/**
	 * ループの設定
	 * @param sequence シーケンス
	 * @param looped 設定するループフラグ
	 */
	virtual void setLooped(int sequence, bool looped){
		getSequence(sequence)->looped_ = looped;
	}

	/**
	 * ループの取得
	 * @param sequence シーケンス
	 * @return ループするならtrue
	 */
	virtual bool isLooped(int sequence) const{
		return getSequence(sequence)->looped_;
	}

	//--------------------------------------------------------------------------
	// 名前
	//--------------------------------------------------------------------------
	/**
	 * 名前の取得
	 * @return 名前
	 */
	virtual const String& getName() const{ return name_; }

	//--------------------------------------------------------------------------
	// マネージャ
	//--------------------------------------------------------------------------
	/**
	 * マネージャの取得
	 * @return マネージャ
	 */
	virtual AnimationManager* getManager() const{ return manager_; }

	//--------------------------------------------------------------------------
	// リファレンスカウンタ
	//--------------------------------------------------------------------------
	/**
	 * リファレンスの追加
	 * @return リファレンスカウント
	 */
	int addReference(){
		referenceCount_++;
		return referenceCount_;
	}

	/**
	 * リファレンスの削除
	 * @return リファレンスカウント
	 */
	int removeReference(){
		referenceCount_--;
		return referenceCount_;
	}

	/**
	 * リファレンスカウントの取得
	 * @return リファレンスカウント
	 */
	int getReferenceCount() const{ return referenceCount_; }

	//--------------------------------------------------------------------------
	// RTTI
	//--------------------------------------------------------------------------
	/**
	 * カメラアニメーションデータかどうか
	 * @return カメラアニメーションデータならtrue
	 */
	virtual bool isCameraAnimationData() const{ return false; }

	/**
	 * カメラアニメーションデータへのキャスト
	 * @return カメラアニメーションデータ。型が違えばNULLを返す。
	 */
	virtual CameraAnimationData* castCameraAnimationData() const{
		if(isCameraAnimationData()){ return (CameraAnimationData*)this; }
		return NULL;
	}

	//--------------------------------------------------------------------------
	/**
	 * シーンノードアニメーションデータかどうか
	 * @return シーンノードアニメーションデータならtrue
	 */
	virtual bool isSceneNodeAnimationData() const{ return false; }

	/**
	 * シーンノードアニメーションデータへのキャスト
	 * @return シーンノードアニメーションデータ。型が違えばNULLを返す。
	 */
	virtual SceneNodeAnimationData* castSceneNodeAnimationData() const{
		if(isSceneNodeAnimationData()){ return (SceneNodeAnimationData*)this; }
		return NULL;
	}

	//--------------------------------------------------------------------------
	/**
	 * キャラクタモデルアニメーションデータかどうか
	 * @return キャラクタモデルアニメーションデータならtrue
	 */
	virtual bool isCharacterModelAnimationData() const{ return false; }

	/**
	 * キャラクタモデルアニメーションデータへのキャスト
	 * @return キャラクタモデルアニメーションデータ。型が違えばNULLを返す。
	 */
	virtual CharacterModelAnimationData*
		castCharacterModelAnimationData() const{
		if(isCharacterModelAnimationData()){
			return (CharacterModelAnimationData*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------
protected:
	/**
	 * コンストラクタ
	 * @param name 名前
	 * @param manager アニメーションマネージャ
	 */
	AnimationData(const String& name, AnimationManager* manager) :
		name_(name), manager_(manager), referenceCount_(0){}

	/**
	 * デストラクタ
	 */
	virtual ~AnimationData(){}

	/**
	 * シーケンスの取得
	 * @param sequence シーケンス
	 * @return シーケンス
	 */
	virtual Sequence* getSequence(int sequence) = 0;

	/**
	 * シーケンスの取得
	 * @param sequence シーケンス
	 * @return シーケンス
	 */
	virtual const Sequence* getSequence(int sequence) const = 0;

	//--------------------------------------------------------------------------
private:
	// コピーコンストラクタの隠蔽
	AnimationData(const AnimationData& copy);

	// 代入コピーの隠蔽
	void operator =(const AnimationData& copy);

	// 名前
	String name_;
	// アニメーションマネージャ
	AnimationManager* manager_;
	// リファレンスカウント
	int referenceCount_;
};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of ANIMATION_DATA_H_
//------------------------------------------------------------------------------
